rm(list=ls())
options(warn=-1)
library(np)

setwd("C:/your_working_directory")

############# Ichimura #############
load(file="CI.sp1.Rdata")
psi <- res*dF
PSI <- t(psi)%*%psi/length(Fhat)
se <- sqrt(diag(delta0%*%PSI%*%t(delta0)/length(Fhat)))
bw.np <- npregbw(xdat=index,ydat=Y,bws=c(bw.sp1$bw),bandwidth.compute=FALSE)
np <- npreg(bws=bw.np,exdat=mean(index),gradients=TRUE)
m.sp1 <- np$grad*bw.sp1$beta[2:5]
se.sp1 <- sqrt((np$gerr*bw.sp1$beta[2:5])^2 + (np$grad*se)^2)
print(cbind(np$grad,np$gerr))
print(cbind(m.sp1,se.sp1))

############# EJL Estimator #############
rm(list=ls())
load(file="CI.sp3.Rdata")
bw.np <- npregbw(xdat=cbind(index,U),ydat=Y,bws=c(bw.sp3$bw),bandwidth.compute=FALSE)
np <- npreg(bws=bw.np,exdat=cbind(mean(index),mean(U)),gradients=TRUE)
psi <- (res+U*np$grad[2])*dF
PSI <- t(psi)%*%psi/length(Fhat)
se <- sqrt(diag(delta0%*%PSI%*%t(delta0)/length(Fhat)))

m.sp3 <- np$grad[1]*bw.sp3$beta[2:5]
se.sp3 <- sqrt((np$gerr[1]*bw.sp3$beta[2:5])^2 + (np$grad[1]*se)^2)
print(cbind(np$grad[1],np$gerr[1]))
print(cbind(m.sp3,se.sp3))

dd <- colMeans(X1)

dd.1 <- c(dd[1],1,dd[3:5])
dd.0 <- c(dd[1],0,dd[3:5])
index.1 <- sum(dd.1*bw.sp3$beta)
index.0 <- sum(dd.0*bw.sp3$beta)
bw.np <- npregbw(xdat=cbind(index,U),ydat=Y,bws=c(bw.sp3$bw),bandwidth.compute=FALSE)
np.1 <- npreg(bws=bw.np,exdat=cbind(index.1,0),gradients=TRUE)
np.0 <- npreg(bws=bw.np,exdat=cbind(index.0,0),gradients=TRUE)
m.sp3 <- np.1$mean - np.0$mean
se.sp3 <- sqrt(np.1$merr^2 + np.0$merr^2)
print(cbind(m.sp3,se.sp3))

dd.4 <- c(dd[1:2],4,dd[4:5])
dd.3 <- c(dd[1:2],3,dd[4:5])
dd.2 <- c(dd[1:2],2,dd[4:5])
dd.1 <- c(dd[1:2],1,dd[4:5])
index.4 <- sum(dd.4*bw.sp3$beta)
index.3 <- sum(dd.3*bw.sp3$beta)
index.2 <- sum(dd.2*bw.sp3$beta)
index.1 <- sum(dd.1*bw.sp3$beta)
bw.np <- npregbw(xdat=cbind(index,U),ydat=Y,bws=c(bw.sp3$bw),bandwidth.compute=FALSE)
np.4 <- npreg(bws=bw.np,exdat=cbind(index.4,0),gradients=TRUE)
np.3 <- npreg(bws=bw.np,exdat=cbind(index.3,0),gradients=TRUE)
np.2 <- npreg(bws=bw.np,exdat=cbind(index.2,0),gradients=TRUE)
np.1 <- npreg(bws=bw.np,exdat=cbind(index.1,0),gradients=TRUE)
m.sp21 <- np.2$mean - np.1$mean
m.sp32 <- np.3$mean - np.2$mean
m.sp43 <- np.4$mean - np.3$mean
se.sp21 <- sqrt(np.2$merr^2 + np.1$merr^2)
se.sp32 <- sqrt(np.3$merr^2 + np.2$merr^2)
se.sp43 <- sqrt(np.4$merr^2 + np.3$merr^2)
print(cbind(rbind(m.sp21,m.sp32,m.sp43),rbind(se.sp21,se.sp32,se.sp43)))