rm(list=ls())
options(warn=-1)
library(np)

setwd("C:/your_working_directory")

# Ichimura
load(file="sp1.Rdata")
X1 <- as.matrix(cbind(X,Xe))

index <- X1 %*% bw.sp1$beta
W <- as.matrix(data.frame(Y,1))
tww <- npksum(txdat=index,
              tydat=W,
              weights=W,
              leave.one.out=TRUE,
              bandwidth.divide=TRUE,bws=bw.sp1$bw)$ksum
denom <- tww[2,2,]
Fhat <- tww[1,2,]/denom
res <- Y - Fhat

h <- bw.sp1$bw

ksum.1 <- rep(NA,length(Fhat)); ksum.1.s <- matrix(NA,length(Fhat),ncol(X1)-1)
ksum.2 <- rep(NA,length(Fhat)); ksum.2.s <- matrix(NA,length(Fhat),ncol(X1)-1)

print(date())
ptm <- proc.time()
for(i in 1:length(Fhat)){
print(i)
ksum.1[i] <- npksum(txdat=index[-i], exdat=index[i]-h/2,tydat=Y[-i],bws=bw.sp1$bw)$ksum/
  npksum(txdat=index[-i],exdat=index[i]-h/2,bws=bw.sp1$bw)$ksum

ksum.2[i] <- npksum(txdat=index[-i], exdat=index[i]+h/2,tydat=Y[-i],bws=bw.sp1$bw)$ksum/
  npksum(txdat=index[-i],exdat=index[i]+h/2,bws=bw.sp1$bw)$ksum
for(j in 1:(ncol(X1)-1)){  
ksum.1.s[i,j] <- npksum(txdat=index[-i]-h/2, exdat=index[i],tydat=Y[-i]*X1[-i,j+1],bws=bw.sp1$bw)$ksum/
  npksum(txdat=index[-i]-h/2,exdat=index[i],tydat=X1[-i,j+1],bws=bw.sp1$bw)$ksum

ksum.2.s[i,j] <- npksum(txdat=index[-i]+h/2, exdat=index[i],tydat=Y[-i]*X1[-i,j+1],bws=bw.sp1$bw)$ksum/
  npksum(txdat=index[-i]+h/2,exdat=index[i],tydat=X1[-i,j+1],bws=bw.sp1$bw)$ksum
}
}
print(proc.time() - ptm)
print(date())

dF <- matrix(NA,length(Fhat),ncol(X1)-1)
for(j in 1:(ncol(X1)-1)){
dF[,j]<-X1[,j+1]*(ksum.2-ksum.1)/h+(ksum.2.s[,j]-ksum.1.s[,j])/h
}

delta0 <- solve(t(dF)%*%dF/length(Fhat))
save(list=ls(),file="CI.sp1.Rdata")

psi <- res*dF
PSI <- t(psi)%*%psi/length(Fhat)
se <- sqrt(diag(delta0%*%PSI%*%t(delta0)/length(Fhat)))
ci.u <- bw.sp1$beta[2:ncol(X1)]+1.96*se
ci.l <- bw.sp1$beta[2:ncol(X1)]-1.96*se
print(cbind(ci.l,ci.u))

bw.np <- npregbw(xdat=index,ydat=Y,bws=c(bw.sp1$bw),bandwidth.compute=FALSE)
np <- npreg(bws=bw.np,exdat=mean(index),gradients=TRUE)
print(colMeans(gradients(np)))

