rm(list=ls())
options(warn=-1)
library(foreign)

setwd("C:/your_working_directory")

load(file="PSID.Rdata")

tabla <- format(
cbind(
apply(datos,2,FUN=mean),
apply(datos,2,FUN=sd),
apply(datos,2,FUN=quantile,probs=0.25),
apply(datos,2,FUN=quantile,probs=0.50),
apply(datos,2,FUN=quantile,probs=0.75),
apply(datos,2,FUN=min),
apply(datos,2,FUN=max)
),digits=3,justify="right")
colnames(tabla) <- c("Mean","Std. Dev.","25% Q.","Median","75% Q.","Min.","Max.")

write.table(tabla, "clipboard", sep="\t", row.names=TRUE, col.names=TRUE)
