rm(list=ls())
load(file="C:/your_working_directory/bw1.Rdata")

library(np)
source("console.R")
source("util.R")
source("np.singleindex.ejl.R")


optim.abstol <- 1e-4
optim.reltol <- 1e-4

attach(datos)
U <- resid(npreg(bws=bw1))
X <- cbind(state,edu,round(exp(logsize)),age)
Xe <- income
Y <- d
detach(datos)

print(date())
ptm <- proc.time()
        # Orig. Ichimura
        bw.sp1 <- npindexbw(xdat=cbind(X,Xe), ydat=Y, method="ichimura",
                  optim.method ="Nelder-Mead",
                  optim.reltol=optim.reltol,
                  optim.abstol=optim.abstol,
                  nmulti=5)
        save(U,X,Xe,Y,datos,bw1,bw.sp1,file="sp1.Rdata")
print(proc.time() - ptm)
print(date())

print(date())
ptm <- proc.time()
        # EJL Estimator
        bw.sp3 <- np.singleindex.ejl(xdat=X, ydat=Y,gdat=U,wdat=1,bws=bw.sp2,
                                optim.method ="Nelder-Mead",
                                optim.reltol=optim.reltol,
                                optim.abstol=optim.abstol,
                                nmulti=5)
        save(U,X,Xe,Y,datos,bw1,bw.sp3,file="sp3.Rdata")
print(proc.time() - ptm)
print(date())
