rm(list=ls())
options(warn=-1)
library(foreign)
library(np)

setwd("C:/your_working_directory")
load(file="PSID.Rdata")

attach(datos)
plot1 <- npplot(bws=bw1,neval=50,
                plot.errors.method="bootstrap", 
                plot.errors.center="bias-corrected",
                plot.errors.type="quantiles",
                plot.errors.style ="band",
                plot.behavior="plot-data")

plot2 <- npplot(bws=bw2,neval=50,
                plot.errors.method="bootstrap", 
                plot.errors.center="bias-corrected",
                plot.errors.type="quantiles",
                plot.errors.style ="band",
                plot.behavior="plot-data")
detach(datos)

income.eval <- fitted(plot1$r1)
income.se <- se(plot1$r1)
income.lower.ci <- income.eval + income.se[,1]
income.upper.ci <- income.eval + income.se[,2]

age.eval <- plot1$r1$eval[,1]
xlim <- range(age.eval)
ylim <- range(c(income.eval,income.lower.ci,income.upper.ci))

par(mar = c(5, 4, 4, 5))
plot(NULL,xlim=xlim,ylim=ylim,cex=0.2,xlab="Age",ylab="log(Income)",las=1)
lines(age.eval,income.eval,lwd=2)
lines(age.eval,income.lower.ci,lty=3,lwd=2)
lines(age.eval,income.upper.ci,lty=3,lwd=2)
par(new=T)

d.eval <- fitted(plot2$r1)
d.se <- se(plot2$r1)
d.lower.ci <- d.eval + d.se[,1]
d.upper.ci <- d.eval + d.se[,2]

age.eval <- plot2$r1$eval[,1]
xlim <- range(age.eval)
ylim <- range(c(d.eval,d.lower.ci,d.upper.ci))

plot(NULL,xlim=xlim,ylim=ylim,cex=0.2,axes=FALSE,xlab="",ylab="",mgp=c(3,2,0),las=1)
axis(4,pretty(ylim),las=1)
lines(age.eval,d.eval,lwd=2,col="gray")
lines(age.eval,d.lower.ci,lty=3,lwd=2,col="gray")
lines(age.eval,d.upper.ci,lty=3,lwd=2,col="gray")
mtext(4, text = "Migration Probability", line = 3)

savePlot(filename="C:/your_working_directory/fig1",type=c("ps"))
